rgw: Missing error handling when gen_rand_alphanumeric is failing

09/15/2017 12:42 PM - Jens Harbott

Status: Resolved % Done: 0%

Priority: High Spent time: 0.00 hour

Assignee: Casey Bodley   

Category:    

Target version: v0.94.10   

Source:  Affected Versions:  

Tags:  ceph-qa-suite:  

Backport: luminous Pull request ID:  

Regression: No Crash signature (v1):  

Severity: 1 - critical Crash signature (v2):  

Reviewed:    

Description

The function gen_rand_alphanumeric() tries to read some randomness from /dev/urandom and converts it into a string. The read

operation may fail (e.g. with "Too many open files") and there will be a negative error code returned.

int gen_rand_alphanumeric(CephContext *cct, char *dest, int size) 

/* size should be the required string size + 1 */

{

  int ret = get_random_bytes(dest, size);

  if (ret < 0) {

    lderr(cct) << "cannot get random bytes: " << cpp_strerror(-ret) << dendl;

    return ret;                  

  }

...

}

 

The consuming function append_rand_alpha() however does not check the return code, it uses the uninitialized char buf and

appends that to the result string.

static inline void append_rand_alpha(CephContext *cct, const string& src, string& dest, int len)

{

  dest = src;

  char buf[len + 1];

  gen_rand_alphanumeric(cct, buf, len);

  dest.append("_");

  dest.append(buf);

}

 

As a result, when this happens while an object is being copied, we see its tag and prefix fields containing garbage instead of the

expected 24 character string. In particular the prefix field seems to always contain ".P_" now, leading to collisions for tail object

names and in the long run to data loss, as a second objects tail objects will now overwrite those of the first object.

Originally found in v0.94.10 but the code looks still the same in master.

Related issues:

Related to rgw - Bug #22006: RGWCrashError: RGW will crash when generating ra... Resolved 11/02/2017

Related to rgw - Bug #22225: rgw:socket leak in s3 multi part upload In Progress 11/22/2017

Copied to rgw - Backport #21851: luminous: rgw: Missing error handling when g... Rejected
History

#1 - 09/18/2017 11:46 AM - Jens Harbott

In order to reproduce, just make /dev/urandom inaccessible for some time, e.g. run (on the rgw node):

mv /dev/urandom /dev/blah;sleep 60; mv /dev/blah /dev/urandom

 

During these 60 seconds now run on a client node:

$ dd if=/dev/urandom of=test01 count=520 bs=1024

520+0 records in

520+0 records out

532480 bytes (532 kB) copied, 0.044453 s, 12.0 MB/s

$ dd if=/dev/urandom of=test02 count=520 bs=1024

520+0 records in

520+0 records out

532480 bytes (532 kB) copied, 0.0425381 s, 12.5 MB/s

$ s3cmd put test01  s3://test1/atest01

test01 -> s3://test1/atest01  [1 of 1]

 532480 of 532480   100% in    0s     3.57 MB/s  done

$ s3cmd put test02  s3://test1/atest02

test02 -> s3://test1/atest02  [1 of 1]

 532480 of 532480   100% in    0s     3.91 MB/s  done

 

Now the first object is corrupted, as its tail object has been overwritten by the second PUT.

$ s3cmd get s3://test1/atest01 atest01

s3://test1/atest01 -> atest01  [1 of 1]

 532480 of 532480   100% in    0s    24.54 MB/s  done

WARNING: MD5 signatures do not match: computed=949048077122cc83f883a72b690db3cb, received="c9212fd208c64173a7b

4b1e057f5b752" 

 

One will also get truncated objects when one of these objects is removed, see http://tracker.ceph.com/issues/20107 and 

http://tracker.ceph.com/issues/20166 for related issues.
#2 - 09/18/2017 02:00 PM - Casey Bodley

- Status changed from New to 12

- Assignee set to Casey Bodley

#3 - 09/26/2017 06:12 PM - Casey Bodley

- Status changed from 12 to Fix Under Review

https://github.com/ceph/ceph/pull/17972

#4 - 10/05/2017 06:19 PM - Yehuda Sadeh

- Priority changed from Normal to High

#5 - 10/19/2017 05:34 PM - Abhishek Lekshmanan

- Status changed from Fix Under Review to Pending Backport

- Backport set to Luminous

Jewel backports may need a seperate fix

#6 - 10/19/2017 05:35 PM - Abhishek Lekshmanan

- Copied to Backport #21851: luminous: rgw: Missing error handling when gen_rand_alphanumeric is failing added

#7 - 10/20/2017 09:34 AM - Nathan Cutler

- Backport changed from Luminous to luminous

#8 - 11/08/2017 10:27 AM - Nathan Cutler

- Related to Bug #22006: RGWCrashError: RGW will crash when generating random bucket name and object name during loadgen process added

#9 - 12/13/2017 12:29 PM - Nathan Cutler

Note that the luminous backport is non-trivial because random number generation has been reworked in master.

#10 - 05/17/2018 06:19 PM - Casey Bodley

- Related to Bug #22225: rgw:socket leak in s3 multi part upload added

#11 - 10/09/2019 08:41 AM - Nathan Cutler

- Status changed from Pending Backport to Resolved

While running with --resolve-parent, the script "backport-create-issue" noticed that all backports of this issue are in status "Resolved" or "Rejected".

Powered by TCPDF (www.tcpdf.org)

03/13/2024 3/3

https://github.com/ceph/ceph/pull/17972
http://www.tcpdf.org

